regina::FaceEmbedding< dim, subdim > Class Template Reference
Triangulations | Generic triangulations

Details how a subdim-face of a dim-dimensional triangulation appears within each top-dimensional simplex. More...

`#include <triangulation/generic.h>`

Inheritance diagram for regina::FaceEmbedding< dim, subdim >:

## Public Member Functions

| FaceEmbedding ()
| Default constructor. More...
| FaceEmbedding (Simplex< dim > *simplex, int face)
| Creates a new object containing the given data. More...
| FaceEmbedding (const FaceEmbedding &cloneMe)
| Creates a new copy of the given object. More...
Simplex< dim > * | simplex () const
| Returns the top-dimensional simplex in which the underlying subdim-face of the triangulation is contained. More...
int | face () const
| Returns the corresponding face number of simplex(). More...
Perm< dim+1 > | vertices () const
| Maps vertices (0,...,subdim) of the underlying subdim-face of the triangulation to the corresponding vertex numbers of simplex(). More...
bool | operator== (const FaceEmbeddingBase &rhs) const
| Tests whether this and the given object are identical. More...
bool | operator!= (const FaceEmbeddingBase &rhs) const
| Tests whether this and the given object are different. More...
void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| A default implementation for detailed output. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Detailed Description

### template<int dim, int subdim>
class regina::FaceEmbedding< dim, subdim >

Details how a subdim-face of a dim-dimensional triangulation appears within each top-dimensional simplex.

For small-dimensional faces, this class is typically described using dimension-specific type aliases: VertexEmbedding<dim>, EdgeEmbedding<dim>, TriangleEmbedding<dim>, TetrahedronEmbedding<dim> and PentachoronEmbedding<dim> refer to the cases subdim = 0, 1, 2, 3 and 4 respectively.

For a dim-dimensional triangulation T, each subdim-face F typically belongs to many top-dimensional simplices of T, and therefore has many associated FaceEmbedding objects. These individual FaceEmbedding objects correspond to the top-dimensional simplices of the link of F (which is a (dim - subdim - 1)-dimensional triangulation).

If dim is one of Regina's standard dimensions, then this template is specialised to offer additional dimension-specific aliases. In order to use these specialised classes, you will need to include the corresponding triangulation headers (e.g., triangulation/dim2.h for dim = 2, or triangulation/dim3.h for dim = 3).

Python:\n Python does not support templates. Instead this class
  can be used by appending dimensions dim and subdim as suffices (e.g., FaceEmbedding2_1 and FaceEmbedding3_0 for the two examples above).

Template Parameters

  dim | the dimension of the underlying triangulation. This must be between 2 and 15 inclusive.
  subdim | the dimension of the faces of the underlying triangulation. This must be between 0 and dim-1 inclusive.

## Member Function Documentation

## detail()

std::string regina::Output< FaceEmbeddingBase< dim, subdim > , supportsUtf8 >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## str()

std::string regina::Output< FaceEmbeddingBase< dim, subdim > , supportsUtf8 >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:\n In addition to str(), this is also used as the
  Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## utf8()

std::string regina::Output< FaceEmbeddingBase< dim, subdim > , supportsUtf8 >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeTextLong()

void regina::ShortOutput< FaceEmbeddingBase< dim, subdim > , false >::writeTextLong | ( | std::ostream & | out | ) | const

inline inherited

A default implementation for detailed output.

This routine simply calls T::writeTextShort() and appends a final newline.

Python:\n Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following files:

- triangulation/forward.h
- triangulation/generic/face.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).